package preloader
{
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	
	import tools.Statics;
	
	public class SimpleLinePreloader extends Sprite
	{
		private var preLoader:Shape;
		private var percent:Number;
		private var item:Loader;
		public function SimpleLinePreloader(color:uint,x:Number = 0,y:Number=0,width:Number=100,height:Number = 3)
		{
			preLoader = new Shape();
			preLoader.graphics.beginFill(color);
			preLoader.graphics.drawRect(x,y,width,height);
			preLoader.graphics.endFill();
			
			preLoader.scaleX = 0;
			addChild(preLoader);
		}
		public function setItem(item:Loader):void{
			if(item!=null){
				removeItem(item);
			}
			this.item = item;
			this.addEventListener(Event.ENTER_FRAME,updatePreloader);
		}
		public function removeItem(item:Loader):void{
			this.removeEventListener(Event.ENTER_FRAME,updatePreloader);
			item = null;
			preLoader.scaleX = 0;
		}
		public function updatePreloader(e:Event):void{
			preLoader.scaleX += ((item.contentLoaderInfo.bytesLoaded / item.contentLoaderInfo.bytesTotal) - preLoader.scaleX)/4;
			if(preLoader.scaleX > 0.98){
				preLoader.scaleX = 1;
			}
			if(item.contentLoaderInfo.bytesLoaded == item.contentLoaderInfo.bytesTotal){
				removeItem(item);
			}
		}
	}
}