﻿package tools
{
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class BulkLoader  extends EventDispatcher 
	{
		public var itemURLs:Array;
		public var items:Array;
		private var curLoading:Number;
		public function BulkLoader(URLs:Array) 
		{
			itemURLs = URLs;
			items = new Array();
			curLoading = 0;
		}
		public function load():void{
			loadNextShape();
		}
		private function loadNextShape():void {
			if (curLoading == itemURLs.length) {
				dispatchEvent(new Event("AllLoaded"));
			}else{
				var loader:Loader = new Loader();
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, itemLoaded);
				loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioerror);
				loader.load(new URLRequest(itemURLs[curLoading]));
			}
		}
		private function itemLoaded(e:Event):void {
			var loader:Loader = Loader(e.currentTarget.loader);
			items.push(loader);
			curLoading++;
			loadNextShape();
		}
		private function ioerror(e:IOErrorEvent):void {
			items.push(null);
			curLoading++;
			loadNextShape();
		}
		public function getObject(url:String):DisplayObject {
			var ind:Number = itemURLs.indexOf(url);
			if (ind > -1) {
				return items[ind];
			}else {
				return null;
			}
		}
		
	}
	
}