﻿package transitions
{
	import caurina.transitions.Tweener;
	import flash.display.Sprite;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class AlphaTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		public function AlphaTransition(current:Sprite,old:Sprite,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			this.current.alpha = 0;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear", onComplete:transitionCompleted } );
		}
		private function transitionCompleted():void {
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			current.alpha = 1;
			transitionCompleted();
		}
		
	}
	
}