﻿package transitions 
{
	import caurina.transitions.Tweener;
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class SlideTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		private var oldProp:Object;
		public function SlideTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.LEFT,time:Number=1,startAlpha:Number=1) 
		{	
			this.current = current;
			this.old = old;
			current.alpha = startAlpha;
			if(old){
				if(current.parent.getChildIndex(current)>current.parent.getChildIndex(old))
						current.parent.swapChildren(current, old);
				
				oldProp = new Object();
				oldProp.x = old.x;
				oldProp.y = old.y;
				
				if(direction==TransitionManager.LEFT)
					Tweener.addTween(old, { x:old.x - old.width, time:time, transition:"linear" } );
				else if(direction==TransitionManager.RIGHT)
					Tweener.addTween(old, { x:old.x + old.width, time:time, transition:"linear" } );
				else if(direction==TransitionManager.UP)
					Tweener.addTween(old, { y:old.y - old.height, time:time, transition:"linear" } );
				else if(direction==TransitionManager.DOWN)
					Tweener.addTween(old, { y:old.y + old.height, time:time, transition:"linear" } );
			}
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
		}
		private function transitionCompleted():void {
			if (oldProp) {
				old.x = oldProp.x;
				old.y = oldProp.y;	
			}
			current.alpha = 1;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(old);
			Tweener.removeTweens(current);
			transitionCompleted();
		}
	}
	
}