﻿package transitions
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class TransitionEvent extends Event 
	{
		public static const TransitionCompleted:String = "TransitionCompleted";
		public var current:Sprite;
		public var old:Sprite;
		public function TransitionEvent(type:String,current:Sprite,old:Sprite, bubbles:Boolean=false, cancelable:Boolean=false) 
		{ 
			super(type, bubbles, cancelable);
			this.current = current;
			this.old = old;
		} 
		
		public override function clone():Event 
		{ 
			return new TransitionEvent(type,current,old, bubbles, cancelable);
		} 
		
		public override function toString():String 
		{ 
			return formatToString("TransitionEvent", "type", "bubbles", "cancelable", "eventPhase"); 
		}
		
	}
	
}