package gallery
{
	import transitions.TransitionManager;

	public class TransitionObject
	{
		public var type:String;
		public var shapeURL:String;
		public var time:Number;
		public var direction:String;
		public var subtype:String;
		public var effect:Number;
		public var amount:Number;
		public var startAlpha:Number;
		public var multiplier:Number;
		public var rotate:Number;
		public var color:uint;
		public var delay:Number;
		public var size:Number;
		public var rowAmount:Number;
		public var colAmount:Number;
		public var velocityXMin:Number;
		public var velocityYMin:Number;
		public var velocityXMax:Number;
		public var velocityYMax:Number;
		public var gravity:Number;
		public var smooth:Number;
		public var sweepSubtype:Number;
		public var blurX:Number;
		public var blurY:Number;
		public var quality:Number;
		public function TransitionObject()
		{
			type = TransitionManager.NONE;
			shapeURL = null;
			direction = null;
			subtype= null;
			time = NaN;
			effect= NaN;
			amount= NaN;
			startAlpha= NaN;
			multiplier= NaN;
			rotate= NaN;
			color= NaN;
			delay= NaN;
			size= NaN;
			rowAmount= NaN;
			colAmount= NaN;
			velocityXMin= NaN;
			velocityYMin= NaN;
			velocityXMax= NaN;
			velocityYMax= NaN;
			gravity= NaN;
			smooth= NaN;
			sweepSubtype= NaN;
			blurX= NaN;
			blurY= NaN;
			quality= NaN;
		}
	}
}